routes/admin.php
<?php

use Illuminate\Support\Facades\Route;

Route::get('/', [App\Http\Controllers\Admin\HomeController::class, 'index'])->name('home.index');


Route::get("questions/{question}/duplicate",[App\Http\Controllers\Admin\QuestionController::class,"duplicate"])->name("questions.duplicate");
Route::resource("questions",App\Http\Controllers\Admin\QuestionController::class);

Route::resource("orders",App\Http\Controllers\Admin\OrderController::class);
Route::resource("invoices",App\Http\Controllers\Admin\InvoiceController::class);
Route::resource("users",App\Http\Controllers\Admin\UserController::class);
Route::get("coupons/data-table", [App\Http\Controllers\Admin\CouponController::class,"dataTable"])->name("coupons.data-table");
Route::resource("coupons",App\Http\Controllers\Admin\CouponController::class);


Route::get("settings", [App\Http\Controllers\Admin\SettingController::class,"edit"])->name("settings.edit");
Route::put("settings", [App\Http\Controllers\Admin\SettingController::class,"update"])->name("settings.update");

Route::get("types/data-table/{type}", [App\Http\Controllers\Admin\TypeController::class,"dataTable"])->name("types.data-table");
Route::get("types/order-status", [App\Http\Controllers\Admin\TypeController::class,"orderStatus"])->name("types.order-status");
Route::get("types/business-types", [App\Http\Controllers\Admin\TypeController::class,"businessTypes"])->name("types.business-types");
Route::resource("types",App\Http\Controllers\Admin\TypeController::class)->except("index");

Route::match(["get","put"],'actions/{action}/status', [App\Http\Controllers\Admin\ActionController::class, 'updateStatus'])->name('actions.update_status');
Route::match(["get","put"],'actions/{details}/manage/{offset?}', [App\Http\Controllers\Admin\ActionController::class, 'manage'])->name('actions.manage');
Route::get('orders/{invoice:slug}/manage', [App\Http\Controllers\Admin\TrackingController::class, 'manage'])->name('orders.manage');

Route::get('transactions/{transaction}/details', [App\Http\Controllers\Admin\TransactionController::class, 'details'])->name('transactions.details');

routes/web.php
<?php

use App\Models\Order\Order;
use App\Models\Question\Question;
use App\Models\User\User;
use App\Notifications\NewOrder;
use Illuminate\Support\Facades\Notification;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Route::prefix(LaravelLocalization::setLocale())->middleware(['localeSessionRedirect', 'localizationRedirect'])->group(function () {
    Route::get('/', [App\Http\Controllers\Web\HomeController::class, 'index'])->name('home');

    Route::get('orders', [App\Http\Controllers\Web\OrderController::class, 'index'])->name('orders.index');
    Route::get('orders/{question:key}/create', [App\Http\Controllers\Web\OrderController::class, 'create'])->name('orders.create');
    Route::post('orders/{question}/store', [App\Http\Controllers\Web\OrderController::class, 'store'])->name('orders.store');
    Route::get('invoices/{invoice:slug}/show', [App\Http\Controllers\Web\InvoiceController::class, 'show'])->name('invoices.show');
    Route::put('invoices/{invoice:slug}/apply-coupon', [App\Http\Controllers\Web\InvoiceController::class, 'applyCoupon'])->name('invoices.apply_coupon');
    Route::get('invoices/{invoice:slug}/remove-coupon', [App\Http\Controllers\Web\InvoiceController::class, 'removeCoupon'])->name('invoices.remove_coupon');

    Route::middleware(["auth"])->group(function () {
        Route::get('profile/{page?}', [App\Http\Controllers\Web\ProfileController::class, 'edit'])->name('dashboard.profile.edit');
        Route::put('profile/{page?}', [App\Http\Controllers\Web\ProfileController::class, 'update'])->name('dashboard.profile.update');
        Route::post('invoices/{invoice:slug}/checkout', [App\Http\Controllers\Web\InvoiceController::class, 'checkout'])->name('invoices.checkout');
        Route::get('dashboard', [App\Http\Controllers\DashboardController::class, 'index'])->name('dashboard.index');

        Route::post('tracking/find', [App\Http\Controllers\Web\TrackingController::class, 'find'])->name('tracking.find');
        Route::get('tracking/search', [App\Http\Controllers\Web\TrackingController::class, 'search'])->name('tracking.search');
        Route::get('tracking/{invoice:slug}/show', [App\Http\Controllers\Web\TrackingController::class, 'show'])->name('tracking.show');
    });

    Route::match(["get", "put"], 'actions/{action}/status', [App\Http\Controllers\Web\ActionController::class, 'updateStatus'])->name('actions.update_status');

});


Route::post('transaction/integrates/{method}/{gateway}/process-callback', [App\Http\Controllers\Web\TransactionController::class, 'processCallback']);
Route::get('transaction/integrates/{method}/{gateway}/response-callback', [App\Http\Controllers\Web\TransactionController::class, 'responseCallback']);

Route::resource("uploads", App\Http\Controllers\UploadFileController::class)->except(["show"]);
Route::post("uploads/voice-note", [App\Http\Controllers\UploadFileController::class,"voiceNote"])->name("uploads.voice_note");
Route::get("uploads/show/{storage_code}", [App\Http\Controllers\UploadFileController::class, "show"])->where('storage_code', '(.*)')->name("uploads.show");

app/Models/User/Meta.php
<?php

namespace App\Models\User;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Meta extends Model
{
    protected $guarded = [];

    protected $table = "user_metas";

    public $timestamps = false;

    public function user()
    {
        return $this->belongsTo(User::class);
    }

    public function sync(User $user, $data)
    {

        $data = $this->prepareData($data);

        $attributes = [];
        foreach($data as $key => $value){
            $attributes[] = ["user_id" => $user->id,"key" => $key , "value" => $value];
        }

        if (empty($attributes))
            return $this;

        self::where("user_id", $user->id)->whereIn("key", array_keys($data))->delete();

        return $this->insert($attributes);
    }


    private function prepareData($data){

        return $data;
    }
}

app/Models/User/Permission.php
<?php

namespace App\Models\User;


/**
 * @property \Carbon\Carbon $created_at
 * @property int $id
 * @property \Carbon\Carbon $updated_at
 */
class Permission extends \Spatie\Permission\Models\Permission
{
	protected $fillable = ["name", "label", "guard_name", "desc"];

}

app/Models/User/Role.php
<?php

namespace App\Models\User;

use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Model;

class Role extends \Spatie\Permission\Models\Role
{
	protected $fillable = ["name", "label", "guard_name", "access_level","desc"];

}

app/Models/User/User.php
<?php

namespace App\Models\User;

use App\Models\Invoice\Invoice;
use App\Models\Order\Order;
use App\Models\Type;
use App\Traits\Model\HasMetas;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Illuminate\Support\Str;

use Laravelista\Comments\Commenter;
use Spatie\Permission\Traits\HasRoles;

class User extends Authenticatable
{
    use SoftDeletes,HasRoles, HasFactory, Notifiable,HasMetas, Commenter, Notifiable;


    protected $with = ["metas"];

    protected $meta = Meta::class;
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $guarded = [ ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];


    public function orders()
    {
        return $this->hasMany(Order::class);
    }

    public function invoices()
    {
        return $this->hasMany(Invoice::class);
    }

    public function getFirstNameAttribute()
    {
        return Str::before($this->full_name," ");
    }
    public function getLastNameAttribute()
    {
        return Str::afterLast($this->full_name," ");
    }

    public function businessType()
    {
        return  Type::query()->where("id",$this->getMeta("type_id",0))->first();
    }
}

app/Http/Controllers/Admin/UserController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\User\User;
use Illuminate\Http\Request;
use Illuminate\Support\Arr;

class UserController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $users =   User::withCount('orders')->get();

        $breadcrumbs = [
            ["link" => "admin/", "name" => "Home"],["name" => "Users"]
        ];

        return view("admin.pages.users.index",compact("users","breadcrumbs"));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\User\User  $user
     * @return \Illuminate\Http\Response
     */
    public function show(User $user)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\User\User  $user
     * @return \Illuminate\Http\Response
     */
    public function edit(User $user)
    {
        $breadcrumbs = [
            ["link" => "admin/", "name" => "Home"],["link" => "admin/users", "name" => "All Users"],["name" => "Edit User"]
        ];
        return view("admin.pages.users.edit",compact("user","breadcrumbs"));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\User\User  $user
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, User $user)
    {
        $data = $this->validate($request,[
            "full_name" => "required|min:2|max:40",
            "email" => 'required|min:5|max:40|email|unique:users,email,'.$user->id.',id,deleted_at,NULL',
            "phone" => 'required|max:20|unique:users,phone,'.$user->id.',id,deleted_at,NULL',
            "type_id" => "sometimes",
            "password" => "sometimes",
            "links.*" => "sometimes"

        ]);

        if (isset($data["password"]) && !empty($data['password']))
            $data['password'] = bcrypt($data['password']);
        else
            Arr::forget($data,"password");


        $user->update(Arr::only($data,["full_name","email","phone","password"]));

        if(Arr::has($data,"links")) {
            $user->syncMetas(Arr::get($data, "links"));
        }

        if(Arr::has($data,"type_id")) {
            $user->syncMetas(Arr::only($data, ["type_id"]));
        }

        session()->flash("alert_message", [
            "type" => "success",
            "content" => "User has been updated successfully.",
        ]);

        return response()->json([
            "success" => "true",
            "redirectTo" => redirect()->back()->getTargetUrl()
        ]);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\User\User  $user
     * @return \Illuminate\Http\Response
     */
    public function destroy(User $user)
    {
        $user->delete();
        return back();
    }
}

resources/views/admin/pages/users/edit.blade.php
@extends('layouts.contentLayoutMaster')

{{-- title --}}
@section('title','Edit User')
{{-- venodr style --}}
@section('vendor-styles')

@endsection

{{-- page style --}}
@section('page-styles')

@endsection

@section('content')
    <section id="basic-input" class="page-content">
        <div class="row">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header pb-0">
                        <h4 class="card-title">Edit User : {{$user->full_name}}</h4>
                        <hr>
                    </div>
                    <div class="card-body">
                        <form class="ajax-form" data-alert="#user-update-alert" enctype="multipart/form-data"
                              data-scrolltoalert="true"
                              data-button="#user-update-button" id="user-update-form" method="POST"
                              action="{{route("admin.users.update",$user->id)}}">
                            @method("PUT")
                            <div class="row">
                                <div class="col-md-12">
                                    @component('components.alert')
                                        @slot('alert_theme')  background  @endslot
                                        @slot('alert_type')  {{session('alert_message')["type"]}} @endslot
                                        @slot('alert_content')  {!! session('alert_message')["content"] !!}  @endslot
                                        @slot('custom_class')
                                            mb-1 {{session('alert_message') ? "" : "d-none"}} @endslot
                                        @slot('alert_id')  user-update-alert  @endslot
                                    @endcomponent
                                </div>

                            </div>

                            <div class="row">
                                <div class="col-12">
                                    <div class="form-group">
                                        <div class="controls">
                                            <label>Full Name</label>
                                            <input type="text" class="form-control" name="full_name"
                                                   value="{{$user->full_name}}">
                                        </div>
                                    </div>
                                </div>
                                <div class="col-12">
                                    <div class="form-group">
                                        <div class="controls">
                                            <label>Phone</label>
                                            <input type="text" class="form-control" value="{{$user->phone}}" name="phone">
                                        </div>
                                    </div>
                                </div>
                                <div class="col-12">
                                    <div class="form-group">
                                        <div class="controls">
                                            <label>E-mail</label>
                                            <input type="text" class="form-control" value="{{$user->email}}" name="email">
                                        </div>
                                    </div>
                                </div>
                                <div class="col-12 d-none">
                                    <div class="alert bg-rgba-warning alert-dismissible mb-2"
                                         role="alert">
                                        <button type="button" class="close" data-dismiss="alert"
                                                aria-label="Close">
                                            <span aria-hidden="true">×</span>
                                        </button>
                                        <p class="mb-0">
                                            Your email is not confirmed. Please check your inbox.
                                        </p>
                                        <a href="javascript: void(0);">Resend confirmation</a>
                                    </div>
                                </div>
                                <div class="col-12">
                                    <div class="form-group">
                                        <label>Business Type</label>
                                        @include("partials.types.dropdown",["type" => "Business-Types" , "type_id" => [$user->getMeta("type_id")]])
                                    </div>
                                </div>
                            </div>

                            <hr>
                            <div class="row mt-1">
                                <div class="col-12">
                                    <div class="form-group">
                                        <label>Facebook Page <small>(Optional)</small></label>
                                        <input type="text" class="form-control"  name="links[facebook]" placeholder="Add link" value="{{$user->getMeta("facebook")}}">
                                    </div>
                                </div>
                                <div class="col-12">
                                    <div class="form-group">
                                        <label>Instagram <small>(Optional)</small></label>
                                        <input type="text" class="form-control" name="links[instagram]" placeholder="Add link" value="{{$user->getMeta("instagram")}}">
                                    </div>
                                </div>
                            </div>
                            <hr>
                            <div class="row mt-1">
                                <div class="col-12">
                                    <div class="form-group">
                                        <div class="controls">
                                            <label>Update Password <small>(Optional)</small></label>
                                            <input type="password" class="form-control" value="" placeholder="Set Password" name="password">
                                        </div>
                                    </div>
                                </div>

                            </div>
                            <button type="submit"
                                    class="btn  btn-primary waves-effect waves-light  submit-ajax-form mt-1"
                                    id="user-update-button" data-form="#user-update-form">
                                        <span class="spinner-border spinner-border-sm" style="display: none;"
                                              role="status"></span><span
                                    class="button-text">Update</span>
                            </button>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </section>
@endsection

resources/views/admin/pages/users/index.blade.php
@extends('layouts.contentLayoutMaster')
{{-- page title --}}
@section('title','Users')
{{-- vendor style --}}

{{-- page style --}}
@section('page-styles')
    <link rel="stylesheet" type="text/css" href="{{asset('assets/css/pages/app-invoice.css')}}">
@endsection

@section('content')
    <!-- invoice list -->
    <section class="invoice-list-wrapper ">
        <div class="table-responsive">
            <table class="table  invoice-data-table users-data-table dt-responsive nowrap" style="width:100%">
                <thead>
                <tr>
                    <th></th>
                    <th>
                        <span class="align-middle">#ID</span>
                    </th>
                    <th>Full Name</th>
                    <th>Email</th>
                    <th>Phone</th>
                    <th>Business Type</th>
                    <th>Total Orders</th>
                    <th class="text-center">Actions</th>
                </tr>
                </thead>
                <tbody>
                @foreach($users as $user)
                <tr>
                    <td></td>
                    <td>{{$user->id}}</td>
                    <td>{{$user->full_name}}</td>
                    <td>{{$user->email}}</td>
                    <td>{{$user->phone}}</td>
                    <td class="text-center">{{optional($user->businessType())->name}}</td>
                    <td class="text-center">{{$user->orders_count}}</td>
                    <td class="text-center">
                        <div class="d-inline-flex">
                            <div>
                        <a href="{{route("admin.users.edit",$user->id)}}" data-toggle="tooltip"  data-original-title="Edit" data-placement="top"><i class="bx bx-edit-alt mr-1"></i></a>
                            </div>
                            <div>
                        <form method="POST" action="{{route("admin.users.destroy",$user->id)}}" class="p-0 m-0">
                            @csrf
                            @method("DELETE")
                            <button type="submit" class=" font-small-3 border-0 text-danger bg-transparent m-0 p-0"  data-toggle="tooltip"  data-original-title="Delete" data-placement="top"><i class="bx bx-trash-alt"></i></button>
                        </form>
                            </div>
                        </div>
                    </td>
                </tr>
                @endforeach

                </tbody>
            </table>
        </div>
    </section>
@endsection


{{-- page scripts --}}
@push('scripts')
    <script>
        if ($(".users-data-table").length) {
                var dataListView = $(".users-data-table").DataTable({
                    "iDisplayLength": 50,

                    columnDefs: [
                        {

                        },
                    ],
                    //order: [2, 'asc'],
                    dom:
                        '<"top d-flex flex-wrap"<"action-filters flex-grow-1"f><"actions action-btns d-flex align-items-center">><"clear">rt<"bottom"p>',
                    language: {
                        search: "",
                        searchPlaceholder: "Search User"
                    },

                    responsive: {
                        /* details: {
                             type: "column",
                             target: 0
                         }*/
                    }
                });
            }

    </script>
@endpush